
package de.ivu.elect.presentation.wahlvorschlag.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahlvorschlag.boundary.ListeConversationSelect;
import de.ivu.elect.business.wahlvorschlag.entity.Liste;
import de.ivu.elect.presentation.kandidatur.action.EinzelbewerberListenkandidaturDeleteAction;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.stimmzettel.action.EntityAufStimmzettelDeleteAction;

public class EinzelbewerberListeDeleteAction extends AbstractListeAction implements EntityAufStimmzettelDeleteAction<Liste> {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient ListeConversationSelect listeConversationSelect;

  @Inject
  private transient EinzelbewerberListenkandidaturDeleteAction einzelbewerberListenkandidaturDeleteAction;

  public EinzelbewerberListeDeleteAction() {
    super();
  }

  @Override
  public UseCasePermission getRequiredPermission() {
    return einzelbewerberListenkandidaturDeleteAction.getRequiredPermission();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return einzelbewerberListenkandidaturDeleteAction.getGebietSecurity();
  }

  @Override
  protected boolean isDisabledInternal(@Nonnull Liste liste) {
    return !isEinzelbewerberListe(liste) /* -> ListeDeleteAction */;
  }

  @Override
  protected String doIt(Liste liste) {
    listeConversationSelect.setEntity(liste);

    return einzelbewerberListenkandidaturDeleteAction.doIt(liste.getListenkandidaturen().stream().findFirst().orElse(null));
  }

  @Override
  protected boolean isFireChangeEvent() {
    return true;
  }

  @Override
  public String getDialogName() {
    return einzelbewerberListenkandidaturDeleteAction.getDialogName();
  }

  @Override
  public String getLabelKey() {
    return einzelbewerberListenkandidaturDeleteAction.getLabelKey();
  }

  @Override
  public String getIcon() {
    return einzelbewerberListenkandidaturDeleteAction.getIcon();
  }
}
